- Main Page
- Data Structures
- Files
- Related Pages

# imop.h File Reference

Image operations. More...

`#include "generic.h"`

Go to the source code of this file.

## Defines
Convolution padding modes
#define | VL_CONV_ZERO 0
#define | VL_CONV_CIRC 1
#define | VL_CONV_CONT 2
## Functions
void | vl_convtransp_f (vl_single *dst, vl_single const *src, vl_single const *filt, int width, int height, int filt_width, int mode)
| Convolve along columns and take transpose.
void | vl_convtransp_d (vl_double *dst, vl_double const *src, vl_double const *filt, int width, int height, int filt_width, int mode)
| Convolve along columns and take transpose.
void | vl_imsmooth_f (vl_single *dst, vl_single *temp, vl_single const *src, int width, int height, double sigma)
| Smooth image by Gaussian kernel.
void | vl_imsmooth_d (vl_double *dst, vl_double *temp, vl_double const *src, int width, int height, double sigma)
| Smooth image by Gaussian kernel.

## Detailed Description

Author:
  Andrea Vedaldi

## Define Documentation

#define VL_CONV_CIRC 1

Circular convolution

#define VL_CONV_CONT 2

Pad by continuity

#define VL_CONV_ZERO 0

Zero padding

## Function Documentation

void vl_convtransp_d | ( | vl_double * | dst,
|  | vl_double const * | src,
|  | vl_double const * | filt,
|  | int | width,
|  | int | height,
|  | int | filt_width,
|  | int | mode |
| ) |  |  |

The function convolve the columns of the matrix src by the kernel filt of variance s and writes the transpose of the result to the buffer dst.

Remarks:
  Here `columns' correspond to the fastest varying index. Often image are stored in row-major order, so the `columns' are actually the `rows' of the image.

  To convolve an image by a 2-D separable filter just call this function twice.

  The function can be used to process N-dimensional arrays by stacking them properly.

Parameters:

  | dst | output image buffer.
  | src | input image buffer.
  | filt | filter buffer.
  | width | width of the image.
  | height | height of the image.
  | filt_width | filter half width (total width = 2 `filt_width` + 1).
  | mode | mode flags.

vl_convtransp_f | ( | vl_single * | dst,
|  | vl_single const * | src,
|  | vl_single const * | filt,
|  | int | width,
|  | int | height,
|  | int | filt_width,
|  | int | mode |
| ) |  |  |

The function convolve the columns of the matrix src by the kernel filt of variance s and writes the transpose of the result to the buffer dst.

Remarks:
  Here `columns' correspond to the fastest varying index. Often image are stored in row-major order, so the `columns' are actually the `rows' of the image.

  To convolve an image by a 2-D separable filter just call this function twice.

  The function can be used to process N-dimensional arrays by stacking them properly.

Parameters:

  | dst | output image buffer.
  | src | input image buffer.
  | filt | filter buffer.
  | width | width of the image.
  | height | height of the image.
  | filt_width | filter half width (total width = 2 `filt_width` + 1).
  | mode | mode flags.

void vl_imsmooth_d | ( | vl_double * | dst,
|  | vl_double * | temp,
|  | vl_double const * | src,
|  | int | width,
|  | int | height,
|  | double | sigma |
| ) |  |  |

The functions convolve the image src by a Gaussian kernel of variance s and write the result to the buffer dst. The functions also need a scratch buffer dst of the same size of the buffers src and dst.

The various functions differ by the data type of the image pixels that they process.

Parameters:

  | dst | output image buffer.
  | temp | scratch image buffer.
  | src | input image buffer.
  | width | width of the buffers.
  | height | height of the buffers.
  | sigma | standard deviation of the Gaussian kernel.

vl_imsmooth_f | ( | vl_single * | dst,
|  | vl_single * | temp,
|  | vl_single const * | src,
|  | int | width,
|  | int | height,
|  | double | sigma |
| ) |  |  |

The functions convolve the image src by a Gaussian kernel of variance s and write the result to the buffer dst. The functions also need a scratch buffer dst of the same size of the buffers src and dst.

The various functions differ by the data type of the image pixels that they process.

Parameters:

  | dst | output image buffer.
  | temp | scratch image buffer.
  | src | input image buffer.
  | width | width of the buffers.
  | height | height of the buffers.
  | sigma | standard deviation of the Gaussian kernel.